library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity control is
  port ( 
    half_byte : in STD_LOGIC_VECTOR (3 downto 0); -- 4 bit unsigned half byte
    segment : in STD_LOGIC_VECTOR (2 downto 0);   -- 3 bit address of the segment
    seg : out STD_LOGIC_VECTOR (7 downto 0);      -- segment data pins
    adr : out STD_LOGIC_VECTOR (5 downto 0)       -- segment address pins
  );
end control;

architecture Behavioral of control is
begin

  -- convert the input data
  with half_byte select
  seg(6 downto 0) <= 
	  "0111111" when "0000", --0
	  "0000110" when "0001", --1
	  "1011011" when "0010", --2
	  "1001111" when "0011", --3
	  "1100110" when "0100", --4
	  "1101101" when "0101", --5
	  "1111101" when "0110", --6
	  "0000111" when "0111", --7
	  "1111111" when "1000", --8  
	  "1101111" when "1001", --9
	  "1110111" when "1010", --A
	  "1111100" when "1011", --B
	  "0111001" when "1100", --C	  
	  "1011110" when "1101", --D
	  "1111001" when "1110", --E
	  "1110001" when "1111", --F
     "0000000" when others;

	-- set dot
	seg(7) <= '0';
	
	-- convert the address data
	with segment select
	adr <= 
	  "000001" when "000", -- 0
     "100000" when "001", -- 1
	  "000100" when "010", -- 2
	  "000010" when "011", -- 3
	  "010000" when "100", -- 4
	  "001000" when "101", -- 5
     "000000" when others; 
	  
end Behavioral;

