library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- small memory to store 4 integer values

entity memory is
  port ( 
    reset : in STD_LOGIC;                         -- reset signal
    store : in STD_LOGIC;                         -- store new data signal
    data_in : in STD_LOGIC_VECTOR (31 downto 0);  -- input data
	 address : in STD_LOGIC_VECTOR (1 downto 0);   -- address of the memory cell
	 data_out : out STD_LOGIC_VECTOR (31 downto 0) -- output data
  );
end memory;

architecture Behavioral of memory is

  signal cells : STD_LOGIC_VECTOR (127 downto 0) := (others => '0');
 
begin

  process (reset, store)
  begin
    if reset = '1' then
	   cells <= (others => '0');
    else
	   if store = '1' and store'Event then
	     case address is
		    when "00" => cells(31 downto 0) <= data_in;
		    when "01" => cells(63 downto 32) <= data_in;
			 when "10" => cells(95 downto 64) <= data_in;
			 when "11" => cells(127 downto 96) <= data_in;
			 when others => cells <= (others => '0');
		  end case;
	   end if;
	 end if;
  end process;
  
  with address select
  data_out <= 
    cells(31 downto 0) when "00",
	 cells(63 downto 32) when "01",
	 cells(95 downto 64) when "10",
	 cells(127 downto 96) when "11";

end Behavioral;

